#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

FILE *fp;
char *texto;
struct stat arqstat;


void lerGetc()
{
  int i, nfrs;
  for (i=0; !feof(fp); i++)
    texto[i] = fgetc(fp);
}

void lerGets()
{
  int i, nfrs;
  for (nfrs = 0 ; !feof(fp); nfrs = strlen(texto+nfrs))
    fgets(texto+nfrs, arqstat.st_size, fp);
}

void lerScanf()
{
  int i, nfrs;
  for (nfrs = 0 ; !feof(fp); nfrs = strlen(texto+nfrs))
    fscanf(fp, "%s", texto+nfrs);
}

void lerRead()
{
  int i, nfrs;
  fread(texto, sizeof(char), arqstat.st_size, fp);
}


int main (int argc, char *argv[]) 
{
  char  *arquivo;
 
  if (argc != 2)
    fprintf(stderr,"Forma de Uso: %s arquivo\n",argv[0]);
  else {
    arquivo = strdup (argv[1]);

    if (!stat(arquivo, &arqstat)) {
      texto = calloc (arqstat.st_size + 1, sizeof(char));
      
      fp = fopen (arquivo, "r+");
      if (fp == NULL)
	fprintf(stderr, "Erro ao abrir arquivo %s\n", arquivo);
      else {
	printf("Lendo texto com fgetc() ... ");
	lerGetc();
	printf("feito\n");
	
	rewind(fp);
	memset(texto, '\0', arqstat.st_size + 1);
	printf("Lendo texto com fgets() ... ");
	lerGets();
	printf("feito\n");
	
	rewind(fp);
	memset(texto, '\0', arqstat.st_size + 1);
	printf("Lendo texto com fscanf() ... ");
	lerScanf();
	printf("feito\n");
	
	rewind(fp);
	memset(texto, '\0', arqstat.st_size + 1);
	printf("Lendo texto com fread() ... ");
	lerRead();
	printf("feito\n");

	fclose(fp);     /* fecha arquivo */
      }  /* FIM (fp == NULL) */
    }
  }
}

